<template>
  <div class="edit-popup">
    <popup
      ref="popupRef"
      :title="popupTitle"
      :async="true"
      width="550px"
      @confirm="handleSubmit"
      @close="handleClose"
    >
      <el-form
        ref="formRef"
        :model="formData"
        label-width="90px"
        :rules="formRules"
      >
        <el-form-item label="订单编号" prop="order_sn">
          <el-input
            v-model="formData.order_sn"
            clearable
            placeholder="请输入订单编号"
          />
        </el-form-item>
        <el-form-item label="" prop="user_id">
          <el-input v-model="formData.user_id" clearable placeholder="请输入" />
        </el-form-item>
        <el-form-item label="" prop="admin_id">
          <el-input
            v-model="formData.admin_id"
            clearable
            placeholder="请输入"
          />
        </el-form-item>
        <el-form-item label="提现金额" prop="amount">
          <el-input
            v-model="formData.amount"
            clearable
            placeholder="请输入提现金额"
          />
        </el-form-item>
        <el-form-item
          label="状态：0待审核，1通过，2拒绝，3已转账"
          prop="status"
        >
          <el-input
            v-model="formData.status"
            clearable
            placeholder="请输入状态：0待审核，1通过，2拒绝，3已转账"
          />
        </el-form-item>
      </el-form>
    </popup>
  </div>
</template>

<script lang="ts" setup name="withdrawEdit">
import type { FormInstance } from "element-plus";
import Popup from "@/components/popup/index.vue";
import {
  apiWithdrawAdd,
  apiWithdrawEdit,
  apiWithdrawDetail,
} from "@/api/withdraw";
import { timeFormat } from "@/utils/util";
import type { PropType } from "vue";
defineProps({
  dictData: {
    type: Object as PropType<Record<string, any[]>>,
    default: () => ({}),
  },
});
const emit = defineEmits(["success", "close"]);
const formRef = shallowRef<FormInstance>();
const popupRef = shallowRef<InstanceType<typeof Popup>>();
const mode = ref("add");

// 弹窗标题
const popupTitle = computed(() => {
  return mode.value == "edit" ? "编辑提现申请" : "新增提现申请";
});

// 表单数据
const formData = reactive({
  id: "",
  order_sn: "",
  user_id: "",
  admin_id: "",
  amount: "",
  status: "",
});

// 表单验证
const formRules = reactive<any>({
  order_sn: [
    {
      required: true,
      message: "请输入订单编号",
      trigger: ["blur"],
    },
  ],
  user_id: [
    {
      required: true,
      message: "请输入",
      trigger: ["blur"],
    },
  ],
  admin_id: [
    {
      required: true,
      message: "请输入",
      trigger: ["blur"],
    },
  ],
  amount: [
    {
      required: true,
      message: "请输入提现金额",
      trigger: ["blur"],
    },
  ],
  status: [
    {
      required: true,
      message: "请输入状态：0待审核，1通过，2拒绝，3已转账",
      trigger: ["blur"],
    },
  ],
});

// 获取详情
const setFormData = async (data: Record<any, any>) => {
  for (const key in formData) {
    if (data[key] != null && data[key] != undefined) {
      //@ts-ignore
      formData[key] = data[key];
    }
  }
};

const getDetail = async (row: Record<string, any>) => {
  const data = await apiWithdrawDetail({
    id: row.id,
  });
  setFormData(data);
};

// 提交按钮
const handleSubmit = async () => {
  await formRef.value?.validate();
  const data = { ...formData };
  mode.value == "edit"
    ? await apiWithdrawEdit(data)
    : await apiWithdrawAdd(data);
  popupRef.value?.close();
  emit("success");
};

//打开弹窗
const open = (type = "add") => {
  mode.value = type;
  popupRef.value?.open();
};

// 关闭回调
const handleClose = () => {
  emit("close");
};

defineExpose({
  open,
  setFormData,
  getDetail,
});
</script>
